﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel

Public Class BindingErrorsViewModel
    Implements INotifyPropertyChanged

    Public Sub New()

    End Sub

    Private _nodes As ObservableCollection(Of NodeModel) = NodeProvider.GetNodes()
    Public Property Nodes As ObservableCollection(Of NodeModel)
        Get
            Return _nodes
        End Get
        Set(value As ObservableCollection(Of NodeModel))
            _nodes = value
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Nodes"))
        End Set
    End Property

#Region "SetRedToVisibleCommand"

    Private _setRedToVisibleCommand As DelegateCommand = New DelegateCommand(AddressOf Me.ExecuteSetRedToVisibleCommand) ', AddressOf Me.CanSetRedToVisibleCommand)
    Public ReadOnly Property SetRedToVisibleCommand As ICommand
        Get
            Return _setRedToVisibleCommand
        End Get
    End Property

    'Private Function CanSetRedToVisibleCommand(ByVal e As Object) As Boolean
    '    Return True
    'End Function

    Private Sub ExecuteSetRedToVisibleCommand(ByVal e As Object)
        For Each node In Nodes
            If (node.NodeType = NodeModelType.RedNode) Then
                node.Visible = Visibility.Visible
            End If
        Next
    End Sub

#End Region

#Region "SetRedToCollapsedCommand"

    Private _setRedToCollapsedCommand As DelegateCommand = New DelegateCommand(AddressOf Me.ExecuteSetRedToCollapsedCommand) ', AddressOf Me.CanSetRedToCollapsedCommand)
    Public ReadOnly Property SetRedToCollapsedCommand As ICommand
        Get
            Return _setRedToCollapsedCommand
        End Get
    End Property

    'Private Function CanSetRedToCollapsedCommand(ByVal e As Object) As Boolean
    '    Return True
    'End Function

    Private Sub ExecuteSetRedToCollapsedCommand(ByVal e As Object)
        For Each node In Nodes
            If (node.NodeType = NodeModelType.RedNode) Then
                node.Visible = Visibility.Collapsed
            End If
        Next
    End Sub

#End Region

    Public Event PropertyChanged(sender As Object, e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged
End Class
