﻿Imports System.ComponentModel
Imports System.Collections.ObjectModel

Public Class NodeModel
    Implements INotifyPropertyChanged

    Private _label As String
    Public Property Label() As String
        Get
            Return _label
        End Get
        Set(value As String)
            If value <> _label Then
                _label = value
                RaiseOnPropertyChanged("Label")
            End If
        End Set
    End Property

    Private _toolTip As String
    Public Property ToolTip() As String
        Get
            Return _toolTip
        End Get
        Set(value As String)
            If value <> _toolTip Then
                _toolTip = value
                RaiseOnPropertyChanged("ToolTip")
            End If
        End Set
    End Property

    Private _description As String
    Public Property Description() As String
        Get
            Return _description
        End Get
        Set(value As String)
            If value <> _description Then
                _description = value
                RaiseOnPropertyChanged("Description")
            End If
        End Set
    End Property

    Private _imagePath As String
    Public Property ImagePath() As String
        Get
            Return _imagePath
        End Get
        Set(value As String)
            If value <> _imagePath Then
                _imagePath = value
                RaiseOnPropertyChanged("ImagePath")
            End If
        End Set
    End Property

    Private _visible As Visibility = Visibility.Visible
    Public Property Visible() As Visibility
        Get
            Return _visible
        End Get
        Set(value As Visibility)
            If (_visible <> value) Then
                _visible = value
                RaiseOnPropertyChanged("Visible")
            End If
        End Set
    End Property
    
    Private _nodeType As NodeModelType
    Public Property NodeType() As NodeModelType
        Get
            Return _nodeType
        End Get
        Set(value As NodeModelType)
            If value <> _nodeType Then
                _nodeType = value
                RaiseOnPropertyChanged("NodeType")
            End If
        End Set
    End Property

    Private _connections As ObservableCollection(Of ConnectionModel)
    Public Property Connections() As ObservableCollection(Of ConnectionModel)
        Get
            Return _connections
        End Get
        Set(value As ObservableCollection(Of ConnectionModel))
            'If value <> _connections Then
            _connections = value
            RaiseOnPropertyChanged("Connections")
            'End If
        End Set
    End Property

    Public Sub RaiseOnPropertyChanged(ByVal propertyName As String)
        If (PropertyChangedEvent IsNot Nothing) Then
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
        End If
    End Sub

    Public Event PropertyChanged(sender As Object, e As PropertyChangedEventArgs) Implements INotifyPropertyChanged.PropertyChanged
End Class
